var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { jsx as _jsx } from "react/jsx-runtime";
import ReactECharts from 'echarts-for-react';
import React, { useEffect, useRef } from 'react';
var StackChart = function (props) {
    var _a = React.useState('loading'), status = _a[0], setStatus = _a[1];
    var _b = React.useState([]), chartData = _b[0], setChartData = _b[1];
    var chartRef = useRef(null);
    useEffect(function () {
        if (props.chartData) {
            if (props.chartData.length === 0) {
                setStatus('empty');
                setChartData([]);
            }
            else {
                setStatus('loaded');
                setChartData(props.chartData);
            }
        }
        else {
            getChartDataAsync({ id: props.configuration.setup.id });
        }
    }, [props.chartData]);
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetChartDataAsync(arg)];
                case 1:
                    result = _b.sent();
                    if (!(result === null || result === void 0 ? void 0 : result.data) || result.data.length === 0) {
                        setStatus('empty');
                        setChartData([]);
                    }
                    else {
                        setStatus('loaded');
                        setChartData(result.data.filter(function (item) { return item !== null && item !== undefined; }));
                    }
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setChartData([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    if (status === 'empty') {
        if (props.configuration.emptyComponentChartItem)
            return props.configuration.emptyComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-empty", children: _jsx("h1", { children: "No data for chart item" }) }));
    }
    if (status === 'loading') {
        if (props.configuration.loadingComponentChartItem)
            return props.configuration.loadingComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading chart item..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponentChartItem)
            return props.configuration.errorComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error chart item" }) }));
    }
    var serials = new Set();
    var xValues = new Set();
    if (chartData && Array.isArray(chartData)) {
        chartData.forEach(function (item) {
            var _a, _b, _c, _d;
            serials.add(item[(_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field]);
            xValues.add(item[(_d = (_c = props.configuration.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field]);
        });
    }
    var getOption = function () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17, _18, _19, _20, _21, _22, _23, _24, _25, _26, _27, _28, _29, _30, _31, _32, _33, _34, _35, _36, _37;
        return {
            grid: {
                left: '3%',
                right: '4%',
                bottom: '3%',
                containLabel: true,
            },
            legend: {
                show: (_c = (_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.legend) === null || _b === void 0 ? void 0 : _b.show) !== null && _c !== void 0 ? _c : true,
                orient: ((_e = (_d = props.configuration.setup.chart) === null || _d === void 0 ? void 0 : _d.legend) === null || _e === void 0 ? void 0 : _e.orient) || 'horizontal',
                align: ((_g = (_f = props.configuration.setup.chart) === null || _f === void 0 ? void 0 : _f.legend) === null || _g === void 0 ? void 0 : _g.align) || 'auto',
            },
            tooltip: {
                show: (_k = (_j = (_h = props.configuration.setup.chart) === null || _h === void 0 ? void 0 : _h.tooltip) === null || _j === void 0 ? void 0 : _j.show) !== null && _k !== void 0 ? _k : true,
                trigger: ((_m = (_l = props.configuration.setup.chart) === null || _l === void 0 ? void 0 : _l.tooltip) === null || _m === void 0 ? void 0 : _m.trigger) || 'item',
                backgroundColor: ((_p = (_o = props.configuration.setup.chart) === null || _o === void 0 ? void 0 : _o.tooltip) === null || _p === void 0 ? void 0 : _p.backgroundColor) || '#000',
                borderRadius: ((_r = (_q = props.configuration.setup.chart) === null || _q === void 0 ? void 0 : _q.tooltip) === null || _r === void 0 ? void 0 : _r.borderRadius) || 0,
                textStyle: {
                    fontSize: ((_u = (_t = (_s = props.configuration.setup.chart) === null || _s === void 0 ? void 0 : _s.tooltip) === null || _t === void 0 ? void 0 : _t.textStyle) === null || _u === void 0 ? void 0 : _u.fontSize) || 'normal',
                    color: ((_x = (_w = (_v = props.configuration.setup.chart) === null || _v === void 0 ? void 0 : _v.tooltip) === null || _w === void 0 ? void 0 : _w.textStyle) === null || _x === void 0 ? void 0 : _x.color) || '#fff',
                },
            },
            dataset: {
                source: __spreadArray([
                    __spreadArray([(_z = (_y = props.configuration.setup.chart) === null || _y === void 0 ? void 0 : _y.seri) === null || _z === void 0 ? void 0 : _z.field], Array.from(serials), true)
                ], Array.from(xValues).map(function (xValue) { return __spreadArray([
                    xValue
                ], Array.from(serials).map(function (serial) {
                    var _a, _b, _c;
                    return ((_a = chartData.find(function (item) {
                        var _a, _b, _c, _d;
                        return item[(_b = (_a = props.configuration.setup.chart) === null || _a === void 0 ? void 0 : _a.seri) === null || _b === void 0 ? void 0 : _b.field] === serial &&
                            item[(_d = (_c = props.configuration.setup.chart) === null || _c === void 0 ? void 0 : _c.x_axis) === null || _d === void 0 ? void 0 : _d.field] === xValue;
                    })) === null || _a === void 0 ? void 0 : _a[(_c = (_b = props.configuration.setup.chart) === null || _b === void 0 ? void 0 : _b.y_axis) === null || _c === void 0 ? void 0 : _c.field]) || 0;
                }), true); }), true),
            },
            xAxis: {
                type: 'category',
                min: ((_1 = (_0 = props.configuration.setup.chart) === null || _0 === void 0 ? void 0 : _0.x_axis) === null || _1 === void 0 ? void 0 : _1.min) || undefined,
                max: ((_3 = (_2 = props.configuration.setup.chart) === null || _2 === void 0 ? void 0 : _2.x_axis) === null || _3 === void 0 ? void 0 : _3.max) || undefined,
                axisLabel: {
                    rotate: ((_6 = (_5 = (_4 = props.configuration.setup.chart) === null || _4 === void 0 ? void 0 : _4.x_axis) === null || _5 === void 0 ? void 0 : _5.axisLabel) === null || _6 === void 0 ? void 0 : _6.rotate) || 0,
                },
                splitLine: {
                    lineStyle: {
                        color: ((_10 = (_9 = (_8 = (_7 = props.configuration.setup.chart) === null || _7 === void 0 ? void 0 : _7.x_axis) === null || _8 === void 0 ? void 0 : _8.splitLine) === null || _9 === void 0 ? void 0 : _9.lineStyle) === null || _10 === void 0 ? void 0 : _10.color) || '#e9e9eb',
                        type: ((_14 = (_13 = (_12 = (_11 = props.configuration.setup.chart) === null || _11 === void 0 ? void 0 : _11.x_axis) === null || _12 === void 0 ? void 0 : _12.splitLine) === null || _13 === void 0 ? void 0 : _13.lineStyle) === null || _14 === void 0 ? void 0 : _14.type) ||
                            'solid',
                        width: ((_18 = (_17 = (_16 = (_15 = props.configuration.setup.chart) === null || _15 === void 0 ? void 0 : _15.x_axis) === null || _16 === void 0 ? void 0 : _16.splitLine) === null || _17 === void 0 ? void 0 : _17.lineStyle) === null || _18 === void 0 ? void 0 : _18.width) || 1,
                    },
                },
            },
            yAxis: {
                type: 'value',
                min: ((_20 = (_19 = props.configuration.setup.chart) === null || _19 === void 0 ? void 0 : _19.x_axis) === null || _20 === void 0 ? void 0 : _20.min) || undefined,
                max: ((_22 = (_21 = props.configuration.setup.chart) === null || _21 === void 0 ? void 0 : _21.x_axis) === null || _22 === void 0 ? void 0 : _22.max) || undefined,
                axisLabel: {
                    rotate: ((_25 = (_24 = (_23 = props.configuration.setup.chart) === null || _23 === void 0 ? void 0 : _23.x_axis) === null || _24 === void 0 ? void 0 : _24.axisLabel) === null || _25 === void 0 ? void 0 : _25.rotate) || 0,
                },
                splitLine: {
                    lineStyle: {
                        color: ((_29 = (_28 = (_27 = (_26 = props.configuration.setup.chart) === null || _26 === void 0 ? void 0 : _26.x_axis) === null || _27 === void 0 ? void 0 : _27.splitLine) === null || _28 === void 0 ? void 0 : _28.lineStyle) === null || _29 === void 0 ? void 0 : _29.color) || '#e9e9eb',
                        type: ((_33 = (_32 = (_31 = (_30 = props.configuration.setup.chart) === null || _30 === void 0 ? void 0 : _30.x_axis) === null || _31 === void 0 ? void 0 : _31.splitLine) === null || _32 === void 0 ? void 0 : _32.lineStyle) === null || _33 === void 0 ? void 0 : _33.type) ||
                            'solid',
                        width: ((_37 = (_36 = (_35 = (_34 = props.configuration.setup.chart) === null || _34 === void 0 ? void 0 : _34.x_axis) === null || _35 === void 0 ? void 0 : _35.splitLine) === null || _36 === void 0 ? void 0 : _36.lineStyle) === null || _37 === void 0 ? void 0 : _37.width) || 1,
                    },
                },
            },
            series: Array.from(serials).map(function () {
                return {
                    stack: 'total',
                    type: props.configuration.setup.type === 'stack-area-chart' ? 'line' : 'bar',
                    areaStyle: props.configuration.setup.type === 'stack-area-chart' ? {} : undefined,
                };
            }),
        };
    };
    var onChartClick = function (params) {
        console.log('Chart clicked stack-chart:', params);
    };
    var onEvents = {
        click: onChartClick,
    };
    return _jsx(ReactECharts, { ref: chartRef, option: getOption(), onEvents: onEvents });
};
export default StackChart;
